--- /dev/null	2012-07-09 14:38:14.000000000 +0000
+++ new/usr/src/uts/common/inet/dccp/dccp_stats.h	2012-07-09 14:38:14.195677210 +0000
@@ -0,0 +1,52 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2012 David Hoeppner.  All rights reserved.
+ */
+
+#ifndef	_INET_DCCP_DCCP_STATS_H
+#define	_INET_DCCP_DCCP_STATS_H
+
+#include <sys/netstack.h>
+#include <sys/cpuvar.h>
+
+#ifdef	__cplusplus
+extern "C" {
+#endif
+
+typedef struct dccp_stat_counter_s {
+	uint64_t	dccp_no_listener;
+	uint64_t	dccp_listendrop;
+	uint64_t	dccp_sock_fallback;
+	uint64_t	dccp_rst_unsent;
+} dccp_stat_counter_t;
+
+typedef struct {
+	uint64_t		dccp_stats_cnt;
+	mib2_dccp_t		dccp_sc_mib;
+	dccp_stat_counter_t	dccp_sc_stats;
+} dccp_stats_cpu_t;
+
+/*
+ * MIB-II
+ */
+#define	DCCPS_BUMP_MIB(dccps, x) \
+	BUMP_MIB(&(dccps)->dccps_sc[CPU->cpu_seqid]->dccp_sc_mib, x)
+
+#define	DCCP_STAT(dccps, x)	\
+	((dccps)->dccps_sc[CPU->cpu_seqid]->dccp_sc_stats.x++)
+
+#ifdef	__cplusplus
+}
+#endif
+
+#endif	/* _INET_DCCP_DCCP_STATS_H */
